﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication5
{
    public partial class Form1 : Form
    {
        public static OpcLabs.EasyOpc.UA.UAEndpointDescriptor endpoint = new OpcLabs.EasyOpc.UA.UAEndpointDescriptor("opc.tcp://192.168.0.235:4840");
        OpcLabs.EasyOpc.UA.EasyUAClient euaclient = new OpcLabs.EasyOpc.UA.EasyUAClient();
        public struct numeric_value
        {
            public string opcuaid;
            public double value;
            public bool sucess;
            public Exception error;
        }
        public numeric_value[] tags = new numeric_value[99];
        public Form1()
        {
            InitializeComponent();
            fill_array();
            read_values();
            read_values();
            read_values();
            read_values();
            read_values();
            read_values();
            read_values();
            read_values();
            read_values();
            read_values();
            read_values();
            read_values();
            read_values();
        }

        public void fill_array()
        {
            int i;
            for(i = 0; i < 99; i++)
            {
                tags[i].opcuaid = "nsu=urn:B&R/pv/;s=::AsGlobalPV:Test"+(i+1);
            }
            
        }


        public static numeric_value read_numeric_value(OpcLabs.EasyOpc.UA.EasyUAClient euaclient, string node_id)
        {
            
            numeric_value temp = new numeric_value();
            temp.error = null;
            temp.opcuaid = node_id;
            try
            {
                temp.value = Convert.ToDouble(euaclient.ReadValue(endpoint, node_id));
                temp.sucess = true;
            }
            catch (Exception ex)
            {
                temp.sucess = false;
                temp.error = ex;
            }
            return temp;
        }


        public void read_values()
        {
            System.Diagnostics.Stopwatch sw = new System.Diagnostics.Stopwatch();
            sw.Start();
            int i;
            for (i = 0; i < 99; i++)
            {
                tags[i] = read_numeric_value(euaclient, tags[i].opcuaid);
            }
            sw.Stop();
            System.Windows.Forms.MessageBox.Show(sw.ElapsedMilliseconds.ToString());
        }
    }
}
